package experiments.simpat2014.models.article;

import java.util.List;

import schedframe.resources.CoolEmAllResourceType;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.Node;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.Rack;
import schedframe.resources.computing.coolemall.ComputeBox1;
import schedframe.resources.computing.coolemall.NodeGroup;
import schedframe.resources.computing.profiles.energy.ResourceEvent;
import schedframe.resources.computing.profiles.energy.airthroughput.CustomAirflowStateName;
import schedframe.resources.computing.profiles.energy.power.PState;
import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
import schedframe.resources.devices.Device;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;
import simulator.DataCenterWorkloadSimulator;
import example.energy.BaseEnergyEstimationPlugin;
import example.energy.coolemall.CoolEmAllTestbedMeasurements;
import gridsim.dcworms.DCWormsTags;

public class PowerLeakageEnergyEstimationPlugin extends BaseEnergyEstimationPlugin{

	private static double Tidle = 28;
	private static double Tfull = 60;
	
	public double estimatePowerConsumption(ResourceEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {

		double powerConsumption = 0;
		Device pl = (Device) resource;
		double tempDiff = pl.getComputingResource().getThermalInterface().getRecentTemperature().getValue() - Tidle;
		double factor = 0.01 * tempDiff;
		powerConsumption = factor * pl.getComputingResource().getPowerInterface().getRecentPowerUsage().getValue();
		/*Device pl = (Device) resource;
		if(pl.getComputingResource().getThermalInterface().getRecentTemperature().getValue() > 90){
			powerConsumption = powerConsumption + 15;
		}*/
		return powerConsumption;
	}


}
